Package fr.gouv.vitam.worker.core.plugin.lfc_traceability

# Class LogbookObjectGroupLifeCycleTraceabilityHelper

java.lang.Object
fr.gouv.vitam.worker.core.plugin.lfc_traceability.LogbookLifeCycleTraceabilityHelper
fr.gouv.vitam.worker.core.plugin.lfc_traceability.LogbookObjectGroupLifeCycleTraceabilityHelper

All Implemented Interfaces:
  `LogbookTraceabilityHelper`

public class LogbookObjectGroupLifeCycleTraceabilityHelper extends LogbookLifeCycleTraceabilityHelper

- ## Field Summary

  ### Fields inherited from interface fr.gouv.vitam.logbook.common.traceability.LogbookTraceabilityHelper

  `INITIAL_START_DATE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LogbookObjectGroupLifeCycleTraceabilityHelper(HandlerIO handlerIO, LogbookOperationsClient logbookOperationsClient, ItemStatus itemStatus, String operationID, WorkspaceClientFactory workspaceClientFactory, CloseableIterator<com.fasterxml.jackson.databind.JsonNode> traceabilityDataIterator, String traceabilityEventFileName, String traceabilityZipFileName)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected Select`
  `generateSelectLogbookOperation(LocalDateTime date)`
  `TraceabilityType`
  `getTraceabilityType()`
  `String`
  `getZipName()`
  `void`
  `saveDataInZip(MerkleTreeAlgo algo, TraceabilityFile file)`
  Search for entries to secure with the traceability process and store data in the given Traceability zip file.
  Also, Merkle Algorithm should be updated by adding each wanted entry as a leaf of the tree.

  ### Methods inherited from class fr.gouv.vitam.worker.core.plugin.lfc_traceability.LogbookLifeCycleTraceabilityHelper

  `createLogbookOperationEvent, extractAppendToFinalFile, getDataSize, getMaxEntriesReached, getPreviousMonthStartDate, getPreviousMonthTimestampToken, getPreviousStartDate, getPreviousTimestampToken, getPreviousYearStartDate, getPreviousYearTimestampToken, getStepName, getTimestampStepName, getTraceabilityEndDate, getTraceabilityStartDate, getTraceabilityStatistics, saveEmpty, startTraceability, storeAndDeleteZip`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### LogbookObjectGroupLifeCycleTraceabilityHelper

    public LogbookObjectGroupLifeCycleTraceabilityHelper(HandlerIO handlerIO, LogbookOperationsClient logbookOperationsClient, ItemStatus itemStatus, String operationID, WorkspaceClientFactory workspaceClientFactory, CloseableIterator<com.fasterxml.jackson.databind.JsonNode> traceabilityDataIterator, String traceabilityEventFileName, String traceabilityZipFileName)
    Parameters:
      `handlerIO` - Workflow Input/Output of the traceability event
      `logbookOperationsClient` - used to search the operation to secure
      `itemStatus` - used by workflow, event must be updated here
      `operationID` - of the current traceability process
      `traceabilityDataIterator` -
      `traceabilityEventFileName` -
      `traceabilityZipFileName` -

- ## Method Details

  - ### saveDataInZip

    public void saveDataInZip(MerkleTreeAlgo algo, TraceabilityFile file) throws IOException, TraceabilityException
    Description copied from interface: `LogbookTraceabilityHelper`
    Search for entries to secure with the traceability process and store data in the given Traceability zip file.
    Also, Merkle Algorithm should be updated by adding each wanted entry as a leaf of the tree.
    Parameters:
      `algo` - algorithm used to generate MerkleTree with data.
      `file` - output zip to store data (in some TYPE_COLLECTION.json)
    Throws:
      `IOException` - if any error occurs while writing in traceabilityFile
      `TraceabilityException` - for any other errors specifically in the search / data transformation

  - ### getZipName

    public String getZipName()
    Returns:
      the name of the tmp zip file

  - ### getTraceabilityType

    public TraceabilityType getTraceabilityType()
    Returns:
      the traceabilityType of the implementation class

  - ### generateSelectLogbookOperation

    protected Select generateSelectLogbookOperation(LocalDateTime date) throws InvalidCreateOperationException
    Specified by:
      `generateSelectLogbookOperation` in class `LogbookLifeCycleTraceabilityHelper`
    Throws:
      `InvalidCreateOperationException`